<!--
The top level component for creating a new competition.

Determines how to get the backend implementation and passes that
implementation to the two upload panels.
-->
<template>
    <div id="competition-creation-view">
      <b-card style="margin: 10px">
        <h6 slot="header" class="mb-0" style="font-weight: bold;">Create a Competition</h6>
        <div>
          <span class="left-span">
            <b-form-input
                id="date_due_input"
                type="date"
                class="space-top">
            </b-form-input>
            <b-form-input
                id="name_input"
                class="space-top" 
                placeholder="Competition Name..."
                v-model="name"> 
            </b-form-input>
            <b-form-input
                id="embed_url_input"
                class="space-top" 
                placeholder="Embed url..."
                v-model="embedUrl">
            </b-form-input>
            <tag-list-creator
                class="space-top"
                v-model="this.tags">
            </tag-list-creator>
          </span>

          <span class="right-span">
            <b-form-input
                id="time_due_input"
                type="time"
                class="space-top">
            </b-form-input>
            <b-form-textarea
                id="description_input"
                :rows="4"
                v-model="description"
                placeholder="Description Here ..."></b-form-textarea>
          </span>
        </div>

        <!-- Clear both to make sure that the two upload panels don't try
             to sneak up into the difference in height between the description
             and left fields. -->
        <div style="clear:both">
          <span class="left-span">
            <b-card style="margin-top: 10px">
              <h6 slot="header" class="mb-0" style="font-weight: bold;">Judging Scripts</h6>
              <uploads-panel
                  :handler="this.handler"
                  :function="'registerJudgingFiles'"
                  :upload="this.upload"
                  v-on:upload-done="uploadDone"/>
            </b-card>
          </span>

          <span class="right-span">
            <b-card style="margin-top: 10px">
              <h6 slot="header" class="mb-0" style="font-weight: bold;">Starter Code</h6>
              <uploads-panel 
                  :handler="this.handler" 
                  :function="'registerStarterFiles'" 
                  :upload="this.upload"
                  v-on:upload-done="uploadDone"/>
            </b-card>
          </span>
        </div>

        <b-button variant="primary"
                  class="upload-btn"
                  @click="submitPressed">
          <upload/> Upload
        </b-button>

      </b-card>
    </div>
</template>
<script>
import backend from '@/backend-manager'
import UploadsPanel from '@/components/UploadsPanel'
import TagListCreator from '@/components/TagListCreator'
import Competition from '@/models/Competition'

import Upload from 'vue-material-design-icons/upload.vue'

export default {
    name: 'competition-creation-view',
    components: {
        UploadsPanel: UploadsPanel,
        Upload: Upload,
        TagListCreator: TagListCreator
    },

    created: function() {
        this.handler = backend.getInstance().getCompetitionCreationManager()
    },
    data: function () {
        return {
            // Internal control
            handler: {},
            submitted: false,
            upload: false,

            // Form fields
            name: "",
            description: "",
            tags: [],
            embedUrl: "",

            finishedUploads: 0,
            competition: {}

        }
    },
    methods: {
        submitPressed: async function() {
            if (this.submitted) {
                return
            }

            this.submitted = true;
            var comp = new Competition(null, 
                    this.name, // Title
                    new Date(new Date().getTime() + 1000 * 60 * 60 * 24), // Deadline
                    0, // Submissions
                    this.tags, // Tags
                    this.embedUrl, // EmbedUrl
                    this.description, // Description
                    '') // ImageURl
            
            await this.handler.submit(comp)
            this.competition = comp

            // TODO: Check if this was successful/handle the case that
            // it wasn't.

            this.upload = true
        },
        uploadDone() {
            this.finishedUploads += 1
            console.log('Finished uploads ' + this.finishedUploads)
            if (this.finishedUploads >= 2) {
                this.$router.push({ name: 'ContestView', params: { id: this.competition._id } })
            }
        }
    }
    
}
</script>
<style scoped>
.space-top {
    margin: 4px;
}

.left-span {
    float:left;
    width:48%;
    height:100%;
}

.right-span {
    float:right; 
    width:48%; 
    height:100%;
}

.upload-btn {
    float: left;
    clear: both;
    margin-top: 10px;
    margin-right: 6px;
    min-width: 120px;
}
</style>
